
Redmine - Defect #15105

Redmine::Helpers::Diff missing require

2013-10-10 22:26 - Felix Bünemann

Status: Closed Start date:  

Priority: Normal Due date:  

Assignee:  % Done: 0%

Category:  Estimated time: 0.00 hour

Target version:    

Resolution: Fixed Affected version:  

Description

The lib/redmine/helpers/diff.rb is missing a require 'diff' to load lib/diff.rb so it fails to call diff on an array in inititialize:

>> Redmine::Helpers::Diff.new("foo", "bar")

NoMethodError: undefined method `diff' for ["foo", "bar"]:Array

 This can be reproduced by changing the description of an issue and then clicking on the diff link.

Associated revisions

Revision 12205 - 2013-10-11 19:37 - Toshi MARUYAMA

add unit test of Redmine::Helpers::Diff (#15105)

Revision 12206 - 2013-10-11 19:37 - Toshi MARUYAMA

add missing "require 'diff'" to Redmine::Helpers::Diff (#15105)

Contributed by Felix Bünemann.

Revision 12207 - 2013-10-11 19:37 - Toshi MARUYAMA

remove unneeded "require 'diff'" from WikiController (#15105)

History

#1 - 2013-10-10 22:29 - Felix Bünemann

- File redmine_diff_fix.patch added

#2 - 2013-10-11 10:55 - Toshi MARUYAMA

- Status changed from New to Needs feedback

Felix Bünemann wrote:

This can be reproduced by changing the description of an issue and then clicking on the diff link.

 I cannot reproduce on clean Redmine.

"lib" is autoload.

source:trunk/config/application.rb@12204#L19

#3 - 2013-10-11 14:31 - Felix Bünemann

But it is a Monkey-Patch to the Array class, so how does autoloading help? We're not using the RedmineDiff::Diff class directly, so there is no trigger

for autoloading. Besides that the file lib/diff.rb doesn't even follow conventions for autoloading in rails, because it defines multiple modules that don't

match the file name.

It probably can't be reproduced, if for some reason the require 'diff' has already happened by another controller:

app/controllers/wiki_controller.rb:18:require 'diff'

app/models/wiki_page.rb:18:require 'diff'

 For a simpler way to reproduce just use the rails console:
https://www.redmine.org/projects/redmine/repository/svn/revisions/12204/entry/trunk/config/application.rb#L19


>> Redmine::Helpers::Diff.new("foo", "bar")

NoMethodError: undefined method `diff' for ["bar"]:Array

from lib/redmine/helpers/diff.rb:33:in `initialize'

#4 - 2013-10-12 12:32 - Toshi MARUYAMA

- Status changed from Needs feedback to Closed

Committed in trunk r12206, thanks.

#5 - 2013-10-12 12:32 - Toshi MARUYAMA

- Resolution set to Fixed

Files

redmine_diff_fix.patch 403 Bytes 2013-10-10 Felix Bünemann
